#include <qdialog.h>
#include <qlabel.h>
#include "globals.h"

class SettingsDialog :
	public QDialog
{
	Q_OBJECT
public:
	SettingsDialog(void);
	~SettingsDialog(void);

private slots:
	void nil() {};
	void autoscale( int opt );
	void camera( int opt );
	void diff( int d ) { settings.diff = d; };
	void digest( int d ) { settings.digest = d; };
	void fitness( int f ) { settings.fitness = f; };
	void gmo( bool g ) { settings.gmo = g; };
	void image( int i ) { settings.image = i; };
	void maxspeed( int s ) { settings.maxspeed = s; };
	void mutate( int m ) { settings.mutate = m; };
	void pop( int p ) { settings.pop = p; };
	void radius( int r ) { settings.radius = r; };
	void save( bool s ) { settings.save = s; };
	void shuffle( bool s ) { settings.shuffle = s; };
	void smudge( int s ) { settings.smudge = s; };
	void smudgedist( int s ) { settings.smudgedist = s; };
	void opacity( int o ) { settings.opacity_i = o; settings.opacity_f = o / 100.0; };
	void vision( int v ) { settings.vision = v; };

	void diff_change( int d );
	void smud_change( int s );
	void dist_change( int d );
	void opac_change( int o );

	void scenes();

	void OK();

private:
	QLabel* diff_label;
	QLabel* smud_label;
	QLabel* dist_label;
	QLabel* opac_label;
};
