// Genesaver: copyright 2003 Sam Stafford.

struct Pixel;
class World;

#include "thing.h"
#include "brain.h"
#include "dna.h"

class Animal :
	public Thing
{
public:
	Animal( DNA* dna );
	~Animal(void);

	void Render();
	void RenderFitness();

	void CheckFitness();
	void Eat( Pixel** p, int w, int h );
	void LookAnimals( World* w );
	void LookNear( Pixel** p, int w, int h );
	void LookFar( float c_x, float c_y, float* v_x, float* v_y );
	void Smudge( World* w );
	void Sort( World* w );
	void Step( World* w );

	float r, g, b; //animal color

	float fitness; //current fitness level
	float fitness_d_food;	//fitness gained this step from food
	float fitness_d_flock;	//fitness gained this step from flocking
	float fitness_relative; //relative fitness on 0 to 1 scale.

	float muscles[4]; // x-accel, y-accel, v-accel, turn

	// Velocity vector in linear and polar coords.
	float velocity_x;
	float velocity_y;
	float speed; // magnitude
	float angle; // radians

	float dpp; //digestion per pixel
	float size; //size in image pixels

	bool tagged; //is World->tagged

	float meter_hue; //used for chasecam render

	Animal *hi, *lo;

	Animal* nearest;

	Brain brain;
	DNA* dna;
};
